/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.ergebnis.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class ErgebnisTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart;
    public de.ivu.elect.business.ergebnis.entity.Ergebnisart getErgebnisart(){
      return ergebnisart;
    }
    protected final java.lang.String name;
    public java.lang.String getName(){
      return name;
    }

  public ErgebnisTK(
de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart
, java.lang.String name
  ) {
    super();


      this.ergebnisart = ergebnisart;
      this.name = name;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((ergebnisart == null) ? 0 : ergebnisart.hashCode());
                    result = result + ((name == null) ? 0 : name.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof ErgebnisTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        ErgebnisTK other = (ErgebnisTK) obj;

                if (ergebnisart == null) {
          if (other.ergebnisart != null) {
            return false;
          }
        } else if (!ergebnisart.equals(other.ergebnisart)) {
          return false;
        }
                if (name == null) {
          if (other.name != null) {
            return false;
          }
        } else if (!name.equals(other.name)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return ErgebnisConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(ErgebnisConstants.MESSAGE_KEY_ENTITY_EINZAHL, ErgebnisConstants.MESSAGE_KEY_ERGEBNISART_EINZAHL, ergebnisart));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(ErgebnisConstants.MESSAGE_KEY_ENTITY_EINZAHL, ErgebnisConstants.MESSAGE_KEY_NAME_EINZAHL, name));
        
        return result;
      }


            @Override
            public String toString() {
            return "ErgebnisTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"ergebnisart="+ergebnisart
                            +", name="+name
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(ErgebnisConstants.MESSAGE_KEY_ERGEBNISART_EINZAHL) + "=" +

                                  messages.lokalisiere(ergebnisart)
                
                          + ", " + messages.getMessageForMessageKey(ErgebnisConstants.MESSAGE_KEY_NAME_EINZAHL) + "=" +

                                    name
                
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Ergebnis> java.util.Map<ErgebnisTK, E> mappeErgebnisNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Ergebnis::getErgebnisTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Ergebnis, ErgebnisTK> getErgebnisToTKFunction() {
                return Ergebnis::getErgebnisTK;
                }

}
